/*------------------------------------------------------------------------------
--  This file is a part of the SocExplorer Software
--  Copyright (C) 2014, Plasma Physics Laboratory - CNRS
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-------------------------------------------------------------------------------*/
/*--                  Author : Alexis Jeandet
--                     Mail : alexis.jeandet@lpp.polytechnique.fr
----------------------------------------------------------------------------*/
#include "memchecker.h"

memchecker::memchecker(socexplorerplugin* plugin)
{
    this->plugin = plugin;
}

bool memchecker::checkmemory(unsigned int address,unsigned int size)
{
    bool success = true;
    unsigned int* dataLocal = (unsigned int*)malloc(size);
    unsigned int* dataOnBoard = (unsigned int*)malloc(size);
    for(int i=0;(unsigned int)i<(size>>2);i++)
    {
        dataLocal[i]= (0xFFFF&rand())+(rand()<<16);
    }
    plugin->Write(dataLocal,size>>2,address);
    plugin->Read(dataOnBoard,size>>2,address);
    for(int i=0;(unsigned int)i<(size>>2);i++)
    {
        if(dataLocal[i]!=dataOnBoard[i])
            success=false;
    }

    free(dataLocal);
    free(dataOnBoard);
    return success;
}

bool memchecker::checkdatabits(unsigned int address,unsigned int size)
{
    bool success = true;
    return success;
}


